package es.prodevelop.cit.gvsig.arcims.gui.panels;

import java.awt.Point;
import java.awt.event.ActionEvent;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.plaf.basic.BasicArrowButton;

import org.gvsig.remoteClient.arcims.ArcImsClientP;
import org.gvsig.remoteClient.arcims.ArcImsImageClient;
import org.gvsig.remoteClient.arcims.ArcImsStatus;
import org.gvsig.remoteClient.arcims.exceptions.ArcImsException;
import org.gvsig.remoteClient.arcims.utils.ServiceInfoTags;

import com.iver.andami.PluginServices;
import com.iver.utiles.swing.JComboBox;

import es.prodevelop.cit.gvsig.arcims.gui.panels.utils.ImageFormatComboBox;
import es.prodevelop.cit.gvsig.arcims.gui.wizards.ArcImsWizard;

public class ImageServicePanel extends FeatureServicePanel {
	
	private static final long serialVersionUID = 0;
	
	// protected JComboBox imageFormatCombo;
	protected ImageFormatComboBox imageFormatCombo;
	
	protected BasicArrowButton emergencyArrowButton;
	protected JPanel imageFormatPanel;
	protected JLabel imageFormatLabel;
	
	private String imageFormat;

	public ImageServicePanel(ArcImsWizard parent, boolean prop) {
		super(parent, true, prop);
		imageFormat = ServiceInfoTags.vPNG8;
	}
	
	protected void addImageFormatPanel() {

		imageFormatPanel = new JPanel();
		imageFormatPanel.setBounds(180 - 6, 210 - 8, 501 - 180 - 34, 54); // hasta y = 264 
		imageFormatPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(
						null, PluginServices.getText(this, "choose_image_format"),
						javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
						javax.swing.border.TitledBorder.DEFAULT_POSITION,
						null, null));
		
		
		imageFormatLabel = new JLabel(PluginServices.getText(this, "format"));
		imageFormatLabel.setBounds(14, 20, 155, 21);
		
		imageFormatCombo = new ImageFormatComboBox();
		// imageFormatCombo.setOpaque(false);
		// emergencyArrowButton = new BasicArrowButton(BasicArrowButton.SOUTH);
		// emergencyArrowButton.setBounds(180, 20, 20, 20);
		
		imageFormatCombo.setBounds(170, 20, 135 - 34, 20);
		imageFormatCombo.addActionListener(this);
		imageFormatCombo.setEditable(false);
		
		imageFormatPanel.setLayout(null);
		imageFormatPanel.add(imageFormatCombo);
		// imageFormatPanel.add(emergencyArrowButton);
		imageFormatPanel.add(imageFormatLabel);
		
		imgServiceTab_2.add(imageFormatPanel);
		
		// parentWizard.setImageFormat(((ImageFormatObject) imageFormatCombo.getSelectedItem()).getFormatString());
	}
	
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		
		if (e.getSource() == imageFormatCombo) {
			imageFormat = (String) imageFormatCombo.getSelectedItem();
			if (imageFormat == null) {
				return;
			}
			parentWizard.setImageFormat(captionToFormatInImageFormatCombo(imageFormat));
		}

	}
	
	protected void updateWizardLayerQuery() {
		super.updateWizardLayerQuery();
		System.err.println("Image - updateWizardLayerQuery()");
		parentWizard.setImageFormat(getImageFormat());
	}
	
	public String getImageFormat() {
		return imageFormat;
	}

	public void loadImageFormatCombo(ArcImsImageClient client, ArcImsStatus tmpStatus) {
		try {
			imageFormatCombo.removeAllItems();
			
			if (client.testFromat(tmpStatus, ServiceInfoTags.vPNG8)) {
				imageFormatCombo.addItem("PNG 8 bits");
				imageFormatCombo.setSelectedIndex(imageFormatCombo.getItemCount() - 1);
			}
			
			if (client.testFromat(tmpStatus, ServiceInfoTags.vPNG24)) {
				imageFormatCombo.addItem("PNG 24 bits");
				imageFormatCombo.setSelectedIndex(imageFormatCombo.getItemCount() - 1);
			}
			
			if (client.testFromat(tmpStatus, ServiceInfoTags.vJPEG)) {
				imageFormatCombo.addItem("JPG");
				imageFormatCombo.setSelectedIndex(imageFormatCombo.getItemCount() - 1);
			}
			
			if (client.testFromat(tmpStatus, ServiceInfoTags.vGIF)) {
				imageFormatCombo.addItem("GIF");
				imageFormatCombo.setSelectedIndex(imageFormatCombo.getItemCount() - 1);
			}
			
			parentWizard.setImageFormat(ServiceInfoTags.vPNG8);
		} catch (ArcImsException e) {
			logger.error("While loading image formats combo ", e);
		}
	}

	public void setInImageFormatCombo(String imgFormat) {
		int size = imageFormatCombo.getItemCount();
		String itemi = "";
		String caption = formatToCaptionInImageFormatCombo(imgFormat);

		imageFormatCombo.setSelectedIndex(0);
		for (int i=0; i<size; i++) {
			itemi = (String) imageFormatCombo.getItemAt(i);
			
			if (itemi.compareToIgnoreCase(caption) == 0) {
				imageFormatCombo.setSelectedIndex(i);
				return;
			}
		}
	}

	public void emptyFormatsCombo() {
		imageFormatCombo.removeAll();
	}

	public ImageFormatComboBox getImageFormatCombo() {
		return imageFormatCombo;
	}
	
	private String captionToFormatInImageFormatCombo(String caption) {
		String resp = "Unknown";
		if (caption.compareToIgnoreCase("jpg") == 0) { return ServiceInfoTags.vJPEG; }
		if (caption.compareToIgnoreCase("png 8 bits") == 0) { return ServiceInfoTags.vPNG8; }
		if (caption.compareToIgnoreCase("png 24 bits") == 0) { return ServiceInfoTags.vPNG24; }
		if (caption.compareToIgnoreCase("gif") == 0) { return ServiceInfoTags.vGIF; }
		return resp;
	}

	private String formatToCaptionInImageFormatCombo(String format) {
		String resp = "Unknown";
		if (format.compareToIgnoreCase(ServiceInfoTags.vJPEG) == 0) { return "jpg"; }
		if (format.compareToIgnoreCase(ServiceInfoTags.vPNG8) == 0) { return "PNG 8 bits"; }
		if (format.compareToIgnoreCase(ServiceInfoTags.vPNG24) == 0) { return "PNG 24 bits"; }
		if (format.compareToIgnoreCase(ServiceInfoTags.vGIF) == 0) { return "GIF"; }
		return resp;
	}

	
	

}
