
package org.gvsig.remoteClient.arcims.styling.renderers;

import java.util.Iterator;

import org.gvsig.remoteClient.arcims.styling.symbols.SymbolUtils;
import org.gvsig.remoteClient.arcims.utils.ServiceInfoTags;

import com.iver.cit.gvsig.fmap.core.v02.FLabel;

public class ValueMapLabelRenderer extends ValueMapRenderer implements ILabelRenderer {
	public static final String TAG=	ServiceInfoTags.tVALUEMAPLABELRENDERER;
	
	private String rotationalangles;
	private String labelfield;

	
	
	/**
	 * @param labelField
	 */
	public ValueMapLabelRenderer(String labelField, String alookupField) {
		super(alookupField);
		this.labelfield = labelField;
	}


	/**
	 * Generates an XML representation of the Renderer
	 */
	public String toString(){
		StringBuffer sb = new StringBuffer();
		Iterator it = values.iterator();
		
		while(it.hasNext()) {
			sb.append(((TypeValueMap) it.next()).toString());
		}
		
		return "<"+ValueMapLabelRenderer.TAG+
				" lookupField=\""+lookupField+"\""+
				getParam() +
				"\">\r\n"+
				sb.toString()+
				"</"+ValueMapLabelRenderer.TAG+">\r\n";
	}
	
	private String getParam() {
		String param = "";
		if (SymbolUtils.isVoid(rotationalangles)) param+= " rotationalangles=\"" + rotationalangles + "\"";
		if (SymbolUtils.isVoid(labelfield)) param+= " labelfield=\"" + labelfield + "\"";
		
		return param;
	}
	
	
	/**
	 * @return Returns the labelField.
	 */
	public String getField() {
		return labelfield;
	}

	/**
	 * @param labelField The labelField to set.
	 */
	public void setField(String labelField) {
		this.labelfield = labelField;
	}

	/**
	 * @return Returns the rotationalAngles.
	 */
	public String getRotationalangles() {
		return rotationalangles;
	}

	/**
	 * @param rotationalAngles The rotationalAngles to set.
	 */
	public void setRotationalangles(String rotationalangles) {
		this.rotationalangles = rotationalangles;
	}

}
